using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Auxiliary;
using Cother;
using System.ComponentModel;
using System.Net;
namespace ImprovedXnaGame
{
    public partial class ImprovedGame : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        public Session Session;
        public List<string> CommandsToSendOverInternet = new List<string>();
        public List<string> CommandsBeingSentOverInternet = new List<string>();
        public BackgroundWorker OnlineWorker = new BackgroundWorker();

        [ApplicationWideSetting]
        public Session SavedSession;

        public static ImprovedGame Main;


        public int ConsoleMaxLines = 22;
        public int ConsoleOutputCurrentLine = 0;
        public bool TrackingPermitted = true;
        public ImprovedGame()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            this.IsMouseVisible = false;
            OnlineWorker.DoWork += new DoWorkEventHandler(OnlineWorker_DoWork);
            Main = this;
        }

        void OnlineWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
                List<string> commandos = e.Argument as List<string>;
                foreach (string command in commandos)
                {
                    WebClient wc = new WebClient();
                    wc.DownloadString("http://petrhudecek.ic.cz/starswirl.php?command=" + command);
                }
            }
            catch
            {

            }
        }

        protected override void LoadContent()
        {
            string[] args = Environment.GetCommandLineArgs();
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Root.EXECUTE_DoNotLoadXXLTextures = true;
            Resolution resolution = new Resolution(1024, 768);
            if (args.Length >= 2)
            {
                try
                {
                    string[] wh = args[1].Split('x');
                    int w = Int32.Parse(wh[0]);
                    int h = Int32.Parse(wh[1]);
                    resolution = new Resolution(w, h);
                }
                catch
                {

                }
            }
            if (args.Length >= 4)
            {
                if (args[3] == "donottrack") TrackingPermitted = false;
            }
            Root.Init(this, spriteBatch, graphics, resolution);
            /*     public static Rectangle rectConsoleTop = new Rectangle(3, 3, 1024 - 6, 500);
        public static Rectangle rectConsoleTopInner = new Rectangle(3+2, 3+2, 1024 - 6-4, 500-4);
        Rectangle rectInputLine = new Rectangle(3, 506, 1024 - 6, 30);
        Rectangle rectSuggestions = new Rectangle(3, 539, 1024 - 6 - 203, 226);
        Rectangle rectRecommendedCommands = new Rectangle(1024-203, 539, 200, 226);*/
            rectConsoleTop = new Rectangle(2, 2, resolution.Width - 4, 500);
            rectConsoleTopInner = new Rectangle(5, 5, resolution.Width - 10, 496);
            rectInputLine = new Rectangle(2, 503, resolution.Width - 4, 30);
            int suggestionBoxHeight = resolution.Height - 2 - 535;
            rectSuggestions = new Rectangle(2, 535, resolution.Width *3/4, suggestionBoxHeight);
            rectRecommendedCommands = new Rectangle(resolution.Width *3/4 + 4, 535, resolution.Width *1/4 - 6, suggestionBoxHeight);

            if (args.Length >= 3)
            {
                if (args[2] == "fullscreen")
                {
                    Root.IsFullscreen = true;
                }
            }
         //   Root.DISPLAY_DisplayFPSCounterWhere = new Vector2(10, Root.ScreenHeight - 50);
            InputTextBox = new Textbox("", rectInputLine, false);
            InputTextBox.Activate();
            InputTextBox.EnterPress += new Action<Textbox>(InputTextBox_EnterPress);
            Session = new Session();
            Session.EnterLocation(Session.Locations[LocationID.Splash]);
            Session.GetAvailableCommands(out AvailableCommands, out RecommendedCommands);
            // Add your first game phase here
        }
        public int PreviousConsoleTotalLines = 0;
        public int GreyOutputUntil = -1;
        public void LinesAdded(bool nograying)
        {
            if (!nograying)
            GreyOutputUntil = PreviousConsoleTotalLines;
            if (Session.ConsoleTotalLines > ConsoleMaxLines + ConsoleOutputCurrentLine)
            {
                ConsoleOutputCurrentLine = Session.ConsoleTotalLines - ConsoleMaxLines;
            }
            PreviousConsoleTotalLines = Session.ConsoleTotalLines;
        }

        void InputTextBox_EnterPress(Textbox obj)
        {
            // Command entered.
            if (CurrentSuggestions.Count > 0 && ChosenSuggestion >= 0 && ChosenSuggestion < CurrentSuggestions.Count)
            {
                // Possible command.
                SendCommand(CurrentSuggestions[ChosenSuggestion]);
                CommandsToSendOverInternet.Add(CurrentSuggestions[ChosenSuggestion].TotalString);
            }
            else
            {
                Session.WriteLines("This command does not exist. Only commands displayed under the input box are possible choices.");
                CommandsToSendOverInternet.Add("FAIL: " + obj.Text);
            }
            obj.Text = "";
            OldInputText = "";
        }
     
        protected override void Update(GameTime gameTime)
        {
             if (Root.WasKeyPressed(Keys.Enter, ModifierKey.Alt))
            {
                graphics.ToggleFullScreen();
            }

            InputTextBox.Update();
            if (InputTextBox.Text != OldInputText)
            {
                OldInputText = InputTextBox.Text;
                ChosenSuggestion = 0;
            }
            if (Root.WasKeyPressed(Keys.Down))
            {
                ChosenSuggestion++;
            }
            if (Root.WasKeyPressed(Keys.Up))
            {
                ChosenSuggestion--;
            }
            CurrentSuggestions = new List<Command>();
            foreach (Command c in AvailableCommands)
            {
                if (c.TotalString.ToUpper().Contains(InputTextBox.Text.ToUpper()))
                {
                    CurrentSuggestions.Add(c);
                }
            }
            // Online
            if (!OnlineWorker.IsBusy && TrackingPermitted)
            {
                List<string> commands = new List<string>();
                foreach(string cmd in CommandsToSendOverInternet)
                {
                    commands.Add(cmd);
                }
                CommandsToSendOverInternet.Clear();
                OnlineWorker.RunWorkerAsync(commands);
            }
            Root.Update(gameTime);
            base.Update(gameTime);
        }

        public static Rectangle rectConsoleTop = new Rectangle(3, 3, 1024 - 6, 500);
        public static Rectangle rectConsoleTopInner = new Rectangle(3+2, 3+2, 1024 - 6-4, 500-4);
        Rectangle rectInputLine = new Rectangle(3, 506, 1024 - 6, 30);
        Rectangle rectSuggestions = new Rectangle(3, 539, 1024 - 6 - 203, 226);
        Rectangle rectRecommendedCommands = new Rectangle(1024-203, 539, 200, 226);
        Textbox InputTextBox;
        public int ChosenSuggestion = 0;
        public string OldInputText = "";
        public List<Command> CurrentSuggestions = new List<Command>();

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.FromNonPremultiplied(10,10,10,255));
            spriteBatch.Begin();
            // Here, draw the game.

            // Console output
            Primitives.DrawAndFillRectangle(rectConsoleTop, Color.Black, Color.White, 1);
            for (int i = 0; i < ConsoleMaxLines; i++)
            {
                int lineID = i + ConsoleOutputCurrentLine;
                if (lineID >= Session.ConsoleTotalLines) break;
                Primitives.DrawSingleLineText(Session.ConsoleOutput[lineID], new Vector2(rectConsoleTopInner.X, rectConsoleTopInner.Y + Library.FontConsoleNormal.LineSpacing * i), lineID < GreyOutputUntil ? Color.Gray : Color.White);
            }

            // Inputbox
            Primitives.DrawAndFillRectangle(rectInputLine, Color.Black, Color.White, 1);
            InputTextBox.Draw();

            // Suggestions
            Primitives.DrawAndFillRectangle(rectSuggestions, Color.Black, Color.White, 1);
            List<Command> suggestions = CurrentSuggestions;
            int lnSpacing = Library.FontConsoleNormal.LineSpacing + 2;
            int maxsuggestioncount = rectSuggestions.Height / lnSpacing;
            if (ChosenSuggestion < 0) ChosenSuggestion = maxsuggestioncount - 1;
            if (ChosenSuggestion > maxsuggestioncount - 1) ChosenSuggestion = 0;
            for (int i = 0; i < maxsuggestioncount; i++)
            {
                if (suggestions.Count <= i) break;
                Command c = suggestions[i];
                Rectangle rectSuggestion = new Rectangle(rectSuggestions.X + 3, rectSuggestions.Y + 2 + i * lnSpacing, rectSuggestions.Width - 6, lnSpacing);
                Primitives.DrawSingleLineText(c.TotalString, new Vector2(rectSuggestion.X + 5, rectSuggestion.Y+1), Color.White);
                if (ChosenSuggestion == i)
                {
                    Primitives.FillRectangle(rectSuggestion, Color.Yellow);
                    Primitives.DrawSingleLineText(c.TotalString, new Vector2(rectSuggestion.X+5, rectSuggestion.Y+1), Color.Black);
                }
            }
            if (maxsuggestioncount < suggestions.Count)
            {
                Primitives.DrawSingleLineText((suggestions.Count - maxsuggestioncount) + " more suggestions are hidden", new Vector2(rectSuggestions.X + rectSuggestions.Width - 8 - Library.FontConsoleNormal.MeasureString((suggestions.Count - maxsuggestioncount) + " more suggestions are hidden").X, rectSuggestions.Y + rectSuggestions.Height - lnSpacing), Color.White);
            }

            // Recommended commands
            Primitives.DrawAndFillRectangle(rectRecommendedCommands, Color.Black, Color.White, 1);
            Primitives.DrawSingleLineText("Recommended commands: ", new Vector2(rectRecommendedCommands.X + 2, rectRecommendedCommands.Y + 2), Color.White, Library.FontConsoleNormalBold);
            for (int i = 0; i < 10; i++)
            {
                if (RecommendedCommands.Count <= i) break;
                Command c = RecommendedCommands[i];
                Rectangle rectSuggestion = new Rectangle(rectRecommendedCommands.X + 2, rectRecommendedCommands.Y + 2 + 30 + i * 30, 196, 28);
                string rec = c.TotalString;
                if (rec.Length > 17)
                {
                    rec = rec.Substring(0, 14) + "...";
                }
                Primitives.DrawSingleLineText(rec, new Vector2(rectSuggestion.X, rectSuggestion.Y), Color.White);
            }

            // Draw super-overlay draw code here
         //   Root.DISPLAY_DisplayFPSCounter = true;
            Root.Draw(gameTime);
            spriteBatch.End();
            base.Draw(gameTime);
        }
        protected override void Initialize()
        {
            base.Initialize();
        }
        protected override void UnloadContent()
        {

        }
    }
}
