﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ImprovedXnaGame
{
    [Serializable]
    public class Item
    {
        public ItemID ID;
        public string Name;
        public List<string> PermittedCommands;
        public string Description;
        public bool OnTheOtherSide;
        public override string ToString()
        {
            return Name;
        }
        public Item(ItemID id, string name, string description,
            string[] permittedCommands = null)
        {
            Name = name;
            Description = description;
            ID = id;
            if (permittedCommands != null)
            {
                PermittedCommands = new List<string>(permittedCommands);
            }
            else PermittedCommands = new List<string>();
        }
    }
    public enum ItemID
    {
        Spellbook,
        UnicorniaDaily,
        VioletFlask,
        BlueFlask,
        OrangeFlask,
        GreenFlask,
        CloverPhase1,
        Writings,
        Diamond1,
        MetalDoor,
        Diamond2,
        Pony_RainbowDash,
        Pony_Fluttershy,
        Pony_Rarity,
        Pony_PinkiePie,
        Pony_Applejack,
        Pony_Twilight,
        Rope,
        Instructions,
        FinalDoor,
        Monitor_Western,
        Monitor_Northern,
        Monitor_Eastern,
        Monitor_Southern

    }
}
